Attribute VB_Name = "mdSyncAgent"
'
'Copyright (C) 2003-2005 Funambol
'
'This program is free software; you can redistribute it and/or modify
'it under the terms of the GNU General Public License as published by
'the Free Software Foundation; either version 2 of the License, or
'(at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'

'****************************************************************
'*Module:  mdSyncAgentForVB.bas                                 *
'*Author:  Valeria Olivati - c/o Funambol - Pavia - Italy       *
'*                                                              *
'*This module contains all the functions used for writing the   *
'*EntryIDs files for the items to sync, the functions used for  *
'*counting and reading all the folders in MAPI session, and at  *
'*the end the last function is used in frmPreferences to fill   *
'*the ListBox with the names of all the properties and select   *
'*the selected ones.                                            *
'****************************************************************

Option Explicit

Public Sub prepareSyncFiles(ByRef folderInfoArray() As FolderInfo, ByRef folderType As Integer)
    'prepare the files with the items to sync reading the folders from folderInfoArray
    'and the type from folderType

Dim I As Integer
Dim writingLine As String

On Error GoTo prepareSyncFiles_Err

'prepare the string to write in the file with the type of item
Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    writingLine = "Calendar"
Case mdVariables.FOLDER_TYPE_CON
    writingLine = "Contacts"
Case mdVariables.FOLDER_TYPE_MAIL
    writingLine = "Mail"
Case mdVariables.FOLDER_TYPE_TASK
    writingLine = "Tasks"
Case mdVariables.FOLDER_TYPE_NOTE
    writingLine = "Notes"
End Select

'prepare the files with the related items, starting with the disk folders
For I = 1 To UBound(folderInfoArray)

    'MM if files is cencelled by user, however create the dir and put changed...
    If Not doesFolderExist(folderInfoArray(I).EntryID) Then
            folderInfoArray(I).Changed = True
            
    End If

    If folderInfoArray(I).Changed Then 'if changed = True create the folder
        If Not doesFolderExist(folderInfoArray(I).EntryID) Then
            MkDir folderInfoArray(I).EntryID
        Else 'if the folder exists, has to be deleted and created again
            ChDir folderInfoArray(I).EntryID
            Kill "*.*"
            ChDir ".."
            RmDir folderInfoArray(I).EntryID 'delete the relative folder if exsists
            MkDir folderInfoArray(I).EntryID 'create again
        End If
        mdVariables.lastSync = 0
        'enter the folder
        ChDir folderInfoArray(I).EntryID
        logToDebug CurDir
        'prepare the file with all items
        mdSyncAgent.listAllItemsInFolder mdVariables.nameSpace.GetFolderFromID(folderInfoArray(I).EntryID), folderType
        'the file for the created items has to be equal to all items
        FileCopy mdVariables.NAME_ALL_FILE, mdVariables.NAME_CRE_FILE
        'prepare the file for old items
        FileCopy mdVariables.NAME_ALL_FILE, mdVariables.NAME_OLD_FILE
        'the file for modified items has to be empty
        Open mdVariables.NAME_MOD_FILE For Output As #1
        Write #1, Now 'write the current date and time
        Write #1, writingLine 'write the type of items listed into
        Close #1
        'the file for deleted items has to be empty
        Open mdVariables.NAME_DEL_FILE For Output As #1
        Write #1, Now 'write the current date and time
        Write #1, writingLine 'write the type of items listed into
        Close #1
        ChDir ".."
        logToDebug CurDir
    ElseIf folderInfoArray(I).Selected Then 'if the selected folder to sync remains the same
        'enter the folder
        ChDir folderInfoArray(I).EntryID
        logToDebug CurDir
        'test if the file with Old Items exists
        If mdFileSystem.doesFileExist(mdVariables.NAME_OLD_FILE) Then
            logToDebug "Old Items YES"
            Open mdVariables.NAME_OLD_FILE For Input As #1
            Input #1, mdVariables.lastSync
            Close #1
            mdVariables.oldExists = True
        Else
            logToDebug "Old Items NO"
            mdVariables.lastSync = 0
            mdVariables.oldExists = False
        End If
        'prepare the 4 files with all, created, modificated and deleted items
        mdSyncAgent.listAllItemsInFolder mdVariables.nameSpace.GetFolderFromID(folderInfoArray(I).EntryID), folderType
        mdSyncAgent.listCreItemsInFolder folderType
        mdSyncAgent.listModItemsInFolder mdVariables.nameSpace.GetFolderFromID(folderInfoArray(I).EntryID), folderType
        mdSyncAgent.listDelItemsInFolder folderType
        ChDir ".."
        logToDebug CurDir
    End If
Next I

prepareSyncFiles_Exit:
    Exit Sub

prepareSyncFiles_Err:

    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.Number)
    Select Case actionToDo
    Case 0
        GoTo prepareSyncFiles_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select
End Sub

Sub listAllItemsInFolder(ByRef objFolder As Outlook.MAPIFolder, ByRef folderType As Integer)
    'prepare the file NAME_ALL_FILE, listing all the items in the olFolder objFolder

Dim objItems As Outlook.Items
Dim countItems As Long
Dim writingLine As String

On Error GoTo listAllItemsInFolder_Err

'prepare the string to write in the file with the type of item
Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    writingLine = "Calendar"
Case mdVariables.FOLDER_TYPE_CON
    writingLine = "Contacts"
Case mdVariables.FOLDER_TYPE_MAIL
    writingLine = "Mail"
Case mdVariables.FOLDER_TYPE_TASK
    writingLine = "Tasks"
Case mdVariables.FOLDER_TYPE_NOTE
    writingLine = "Notes"
End Select

'open the file for writing all the items into
Open mdVariables.NAME_ALL_FILE For Output As #1

Write #1, Now 'write the current date and time
Write #1, writingLine 'write the type of items listed into
    
'handle each item
For countItems = 1 To objFolder.Items.Count
    'error control first
    On Error Resume Next
    Err.Clear
    Set objItems = objFolder.Items
    If 0 <> Err.Number Then
        logToDebug "Error : " & objFolder.Items(countItems) & vbNewLine & Err.Description
    ElseIf objItems Is Nothing Then
        MsgBox "The folder " & objFolder.name & " is empty"
    Else 'if all is ok, write the Item's EntryID into the file
        Write #1, objItems.Item(countItems).EntryID
        logToDebug objFolder.name & vbTab & objItems.Item(countItems) & _
        vbTab & objItems.Item(countItems).CreationTime & vbTab & _
        objItems.Item(countItems).LastModificationTime
    End If
Next

Close

listAllItemsInFolder_Exit:
    Exit Sub

listAllItemsInFolder_Err:

    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.Number)
    Select Case actionToDo
    Case 0
        GoTo listAllItemsInFolder_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select
End Sub

Sub listDelItemsInFolder(ByRef folderType As Integer)
    'prepare the file NAME_DEL_FILE, listing all deleted items since last sync

Dim todayDate As Date
Dim typeName As String
Dim allLine As String
Dim oldLine As String
Dim notFound As Boolean
Dim writingLine As String

On Error GoTo listDelItemsInFolder_Err

'MM
ReDim Preserve mdMMVariables.delItems(0)
mdMMVariables.delItems(0) = -1

'prepare the string to write in the file with the type of item
Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    writingLine = "Calendar"
Case mdVariables.FOLDER_TYPE_CON
    writingLine = "Contacts"
Case mdVariables.FOLDER_TYPE_MAIL
    writingLine = "Mail"
Case mdVariables.FOLDER_TYPE_TASK
    writingLine = "Tasks"
Case mdVariables.FOLDER_TYPE_NOTE
    writingLine = "Notes"
End Select

If Not mdVariables.oldExists Then
    FileCopy mdVariables.NAME_ALL_FILE, mdVariables.NAME_OLD_FILE
    Open mdVariables.NAME_DEL_FILE For Output As #3
    Write #3, Now 'write the current date and time
    Write #3, writingLine 'write the type of items listed into
    Close #3
    Exit Sub
End If

'open the files for reading the old items and for writing the deleted the items
Open mdVariables.NAME_OLD_FILE For Input As #2
Open mdVariables.NAME_DEL_FILE For Output As #3

Input #2, todayDate 'read the date of file creation
Input #2, typeName 'read the type of item saved itno
Write #3, Now 'write the current date and time
Write #3, writingLine 'write the type of items listed into

Dim itemFound As Integer
itemFound = 0

'loop through the old file lines
Do While Not EOF(2)
    notFound = True 'flag for item not found
    'open the file for reading all the items
    Open mdVariables.NAME_ALL_FILE For Input As #1

    Input #1, todayDate 'read the date of file creation
    Input #1, typeName 'read the type of item saved itno
    Input #2, oldLine 'read the current line from old file
    
    Do While Not EOF(1)
        Input #1, allLine 'read the current line from all file
        If oldLine = allLine Then 'compare the lines
            notFound = False 'flag for item found
            logToDebug "found!! " & oldLine
            Exit Do
        End If
    Loop
    If notFound = True Then 'if the item is not found write its EntryID into the deleted file
        logToDebug "deleted " & oldLine
        Write #3, oldLine
        
        'MM
        mdMMVariables.containsDelItems = 1
        ReDim Preserve mdMMVariables.delItems(itemFound)
        mdMMVariables.delItems(itemFound) = oldLine
        itemFound = itemFound + 1
        
    End If
    Close #1 'close the all file
Loop

Close 'close all the files

listDelItemsInFolder_Exit:
    Exit Sub

listDelItemsInFolder_Err:

    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.Number)
    Select Case actionToDo
    Case 0
        GoTo listDelItemsInFolder_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select
End Sub

Sub listCreItemsInFolder(ByRef thisType As Integer)
    'prepare the file NAME_CRE_FILE, listing all created items since last sync

Dim todayDate As Date
Dim typeName As String
Dim allLine As String
Dim oldLine As String
Dim notFound As Boolean
Dim writingLine As String
Dim I As Long

'MM
ReDim Preserve mdVariables.createdList(0)
mdVariables.createdList(0) = -1

On Error GoTo listCreItemsInFolder_Err

'prepare the string to write in the file with the type of item
Select Case thisType
Case mdVariables.FOLDER_TYPE_CAL
    writingLine = "Calendar"
Case mdVariables.FOLDER_TYPE_CON
    writingLine = "Contacts"
Case mdVariables.FOLDER_TYPE_MAIL
    writingLine = "Mail"
Case mdVariables.FOLDER_TYPE_TASK
    writingLine = "Tasks"
Case mdVariables.FOLDER_TYPE_NOTE
    writingLine = "Notes"
End Select

If Not mdVariables.oldExists Then 'if old file doesn't exist, copy all file into old and created
    FileCopy mdVariables.NAME_ALL_FILE, mdVariables.NAME_OLD_FILE
    FileCopy mdVariables.NAME_ALL_FILE, mdVariables.NAME_CRE_FILE
    Exit Sub
End If

'if the old file exists
'open the files for reading all the items and for writing the created items
Open mdVariables.NAME_ALL_FILE For Input As #2
Open mdVariables.NAME_CRE_FILE For Output As #3

Input #2, todayDate 'read the date of file creation
Input #2, typeName 'read the type of item saved itno
Write #3, Now 'write the current date and time
Write #3, writingLine 'write the type of items listed into
I = 0

Do While Not EOF(2)
    notFound = True 'flag for item not found
    'open the file for reading the old items
    Open mdVariables.NAME_OLD_FILE For Input As #1

    Input #1, todayDate 'read the date of file creation
    Input #1, typeName 'read the type of item saved itno
    Input #2, allLine 'read the current line from all file
    
    Do While Not EOF(1)
        Input #1, oldLine 'read the current line from old file
        If oldLine = allLine Then 'compare the lines
            notFound = False 'flag for item found
            logToDebug "trovato " & allLine
            Exit Do
        End If
    Loop
    If notFound = True Then 'if the item is not found write its EntryID into the created file
        mdMMVariables.containsNewItems = 1
        logToDebug "created " & allLine
        Write #3, allLine
        ReDim Preserve mdVariables.createdList(I) 'redim createdList array for writing this new EntryID in it
        mdVariables.createdList(I) = allLine
        I = I + 1
       
        
        
    End If
    Close #1 'close the old file
Loop

Close 'close all the files

listCreItemsInFolder_Exit:
    Exit Sub

listCreItemsInFolder_Err:

    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.Number)
    Select Case actionToDo
    Case 0
        GoTo listCreItemsInFolder_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select
    
End Sub

Sub listModItemsInFolder(ByRef objFolder As Outlook.MAPIFolder, ByRef folderType As Integer)
    'prepare the file NAME_MOD_FILE, listing all Modified items since last sync
    
Dim objItems As Outlook.Items
Dim countItems As Integer
Dim writingLine As String
Dim toSkip As Boolean
Dim I As Long

'MM
Dim lung As Integer
lung = -1
Dim numMod As Integer
numMod = 0
'End MM

'MM
ReDim Preserve mdMMVariables.modItems(0)
mdMMVariables.modItems(0) = -1


On Error GoTo listModItemsInFolder_Err

'prepare the string to write in the file with the type of item
Select Case folderType
Case mdVariables.FOLDER_TYPE_CAL
    writingLine = "Calendar"
Case mdVariables.FOLDER_TYPE_CON
    writingLine = "Contacts"
Case mdVariables.FOLDER_TYPE_MAIL
    writingLine = "Mail"
Case mdVariables.FOLDER_TYPE_TASK
    writingLine = "Tasks"
Case mdVariables.FOLDER_TYPE_NOTE
    writingLine = "Notes"
End Select

'open the file for writing the modified items
Open mdVariables.NAME_MOD_FILE For Output As #1

Write #1, Now 'write the current date and time
Write #1, writingLine 'write the type of items listed into

'handle each item
For countItems = 1 To objFolder.Items.Count
    toSkip = False
    'error control first
    On Error Resume Next
    Err.Clear
    Set objItems = objFolder.Items
    If 0 <> Err.Number Then
        logToDebug "Error : " & objFolder.Items(countItems) & vbNewLine & Err.Description
    ElseIf objItems Is Nothing Then
        MsgBox "The folder " & objFolder.name & " is empty"
    Else 'if all is ok, compare the lastSync date with the LastModificationTime date
         'for writing the Item's EntryID into the modificated file
        logToDebug objFolder.name & vbTab & objItems.Item(countItems) & _
        vbTab & objItems.Item(countItems).CreationTime & vbTab & _
        objItems.Item(countItems).LastModificationTime
        
        lung = UBound(mdVariables.createdList)
        Dim dateMod As Date
        dateMod = objItems.Item(countItems).LastModificationTime
        dateMod = DateAdd("h", mdMMVariables.dayLight, dateMod)
        'dateMod = DateAdd("h", 1, dateMod)
        
        If mdVariables.lastSync > 0 Then 'test if these items has been synchronized before
            If DateDiff("s", dateMod, mdVariables.lastSync) < 0 Then 'compare the dates
                'For I = 0 To UBound(mdVariables.createdList) 'search if this item has been listed as created yet
                 For I = 0 To lung
                    If mdVariables.createdList(I) = objItems.Item(countItems).EntryID Then
                        toSkip = True 'flag to skip tshis item as modificated
                        Exit For
                    End If
                Next I
                If toSkip = False Then 'if the item was not to skip write its EntryID into the modificated file
                    Write #1, objItems.Item(countItems).EntryID
                    logToDebug "modified " & objItems.Item(countItems).EntryID & _
                    objItems.Item(countItems).Subject
                    
                    'MM
                    'mdMMVariables.containsModItems = 1
                    ReDim Preserve mdMMVariables.modItems(numMod)
                    mdMMVariables.modItems(numMod) = objItems.Item(countItems).EntryID
                    numMod = numMod + 1
                
                End If
            End If
        End If
    End If
Next

Close

listModItemsInFolder_Exit:
    Exit Sub

listModItemsInFolder_Err:

    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.Number)
    Select Case actionToDo
    Case 0
        GoTo listModItemsInFolder_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select
End Sub

Public Sub readOLFolders(ByRef objFolder As Outlook.MAPIFolder, ByRef folderInfoArray() As FolderInfo)
    'recursive function for reading the existent folders in objFolder folder
    'and saving their EntryIDs in folderInfoArray array
    
Dim countFolder As Integer
Dim I As Integer

'error control first
On Error GoTo readOLFolders_Err

'if folderInfoArray is empty, catch the err.Number for ReDim it to publicCounter dimension
If UBound(folderInfoArray) = 0 Then
    ReDim folderInfoArray(0 To mdVariables.publicCounter)
End If

'absolute position in the array
mdVariables.publicRecounter = mdVariables.publicRecounter + 1
'save all the info for current folder in folderInfoArray structure
folderInfoArray(mdVariables.publicRecounter).EntryID = objFolder.EntryID 'save the EntryID
folderInfoArray(mdVariables.publicRecounter).name = objFolder.name 'save the folder Name
folderInfoArray(mdVariables.publicRecounter).Selected = False 'at the beginning the folder is not selected
folderInfoArray(mdVariables.publicRecounter).Changed = False 'at the beginning the folder is not changed
folderInfoArray(mdVariables.publicRecounter).FolderLevel = mdVariables.readFolderLevel 'store the level of the folder in folders tree

'end of recursion
If objFolder.Folders.Count = 0 Then
    Exit Sub
End If

'save the level of the current folder into the folders tree
mdVariables.readFolderLevel = mdVariables.readFolderLevel + 1

'manage sub folders
For countFolder = 1 To objFolder.Folders.Count
    logToDebug "objFolder.Name:" & objFolder.name & Chr(13) & "objFolder.DefaultItemType:" & objFolder.DefaultItemType
    logToDebug "subfolder name:" & objFolder.Folders(countFolder).name & Chr(13) & "subfolder DefaultItemType:" & objFolder.Folders(countFolder).DefaultItemType
    'reads only the folders of the same Type following a complete tree from the root
    If objFolder.DefaultItemType = objFolder.Folders(countFolder).DefaultItemType Then
        mdSyncAgent.readOLFolders objFolder.Folders(countFolder), folderInfoArray
    End If
Next

readOLFolders_Exit:
    Exit Sub

readOLFolders_Err:
    
    Dim actionToDo As Integer
    
    If Err.Number = 9 Then
        ReDim folderInfoArray(0 To mdVariables.publicCounter, 0 To 1)
        Resume Next
    End If

    actionToDo = mdErrors.fixErrors(Err.Number)
    Select Case actionToDo
    Case 0
        GoTo readOLFolders_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select

End Sub

Public Function countFolders(ByRef objFolder As Outlook.MAPIFolder) As Integer
    'recursive function to count the existing folders in objFolder folder

Dim countFolder As Integer

On Error GoTo countFolders_Err

'manage sub folders
For countFolder = 1 To objFolder.Folders.Count
    mdVariables.publicCounter = mdVariables.publicCounter + 1
    mdSyncAgent.countFolders objFolder.Folders(countFolder)
Next

countFolders = mdVariables.publicCounter

countFolders_Exit:
    Exit Function

countFolders_Err:

    Dim actionToDo As Integer
    
    actionToDo = mdErrors.fixErrors(Err.Number)
    Select Case actionToDo
    Case 0
        GoTo countFolders_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select

End Function

Public Sub fillListItemsSelectedProp(ByRef propertiesArray() As ID_Name_Prop)
    'read the ListBox with the names of all the properties
    'and select the selected ones reading from propertiesArray

Dim I As Integer, J As Integer
    
'error control first
On Error GoTo fillListItemsSelectedProp_Err

frmPreferences.lstSelectedProp.Clear
If UBound(propertiesArray) > 0 Then
    For I = 1 To UBound(propertiesArray)
        For J = 0 To frmPreferences.lstAllProp.ListCount - 1
            If frmPreferences.lstAllProp.ItemData(J) = propertiesArray(I).PropID Then
                frmPreferences.lstAllProp.Selected(J) = True
                Exit For
            End If
        Next J
    Next I
    Call frmPreferences.cmdAdd_Click
End If

fillListItemsSelectedProp_Exit:
    Exit Sub

fillListItemsSelectedProp_Err:

    Dim actionToDo As Integer
    
    If Err.Number = 9 Then Exit Sub
    
    actionToDo = mdErrors.fixErrors(Err.Number)
    Select Case actionToDo
    Case 0
        GoTo fillListItemsSelectedProp_Exit
    Case 1
        Resume
    Case 2
        Resume Next
    End Select

End Sub










